#ifndef PANE_H
#define PANE_H

struct pane;

struct cell {
        wchar_t ch;
        struct {
                int double_sized : 1;
                int italic : 1;
                int bold : 1;
                int underline : 1;
                int blink : 1;
                int inverse :1;
                int subscript : 1;
                int superscript : 1;
                int rapidblink :1;
                int dim : 1;
        } flag;
        unsigned int fgcolor;
        unsigned int bgcolor;
};

#define pane_cleararea pane_clear

//void pane_scroll(struct pane  * p, int y);
void pane_draw(struct pane  * p); 
void pane_setcursor(struct pane *p, int x, int y);
void pane_clear(struct pane *p, int x, int y, int w, int h, struct cell style);
void pane_settext(struct pane * restrict p, int x, int y, wchar_t const * restrict s, int len, struct cell style);
void pane_settext_latin1(struct pane * restrict p, int x, int y, char const * restrict s, int len, struct cell style);
struct pane * pane_create(void);
void pane_setup(struct pane *s, int w, int h); 
void pane_touchall(struct pane *p);
void pane_copy(struct pane *p, int dx, int dy, int sx, int sy, int w, int h);
void pane_showcursor(struct pane *p, bool show);
void pane_toucharea(struct pane *p, int x, int y, int w, int h);
void pane_touchcell(struct pane *p, int x, int y) ;
void pane_tick(struct pane *p);

#endif

/* arch-tag: b611a702-58c5-4846-bdaa-1f9f75df8c87 */
