
#include <malloc.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "unix.h"
#include "panic.h"

/* arch-tag: d7ab6d47-0ea7-470e-acd3-b1eaf4023dac */

struct pty *
spawn_p(char *argv[]) {
        struct pty *pty;
        int child_fd;
        int child_pid;
        pty = malloc(sizeof(struct pty));
        assert(pty);
        memset(pty, 0, sizeof(struct pty));

	child_pid = forkpty(&child_fd,pty->name,NULL,NULL);
	assert(child_pid>=0);
	if(child_pid==0) {
		execvp(argv[0],argv);
                fprintf(stderr, "Could not exec: %s\n", argv[0]);
                getchar();
                exit(2);
	}
        pty->fd = child_fd;
        pty->pid = child_pid;
        tcgetattr(pty->fd, &pty->termios);
        ioctl(pty->fd, TIOCGWINSZ, &pty->winsize);
        return pty;
}



int
writen(int fd, const void *vptr, size_t *n)
{
	size_t		nleft, nwritten;
	const char	*ptr;

	ptr = vptr;	/* can't do pointer arithmetic on void* */
	nleft = *n;
	while (nleft > 0) {
		if ( (nwritten = write(fd, ptr, nleft)) <= 0) {
                        switch(errno) {
                        case EINTR: continue;
                        case EAGAIN:
                                    *n = *n - nleft;
                                    return -1;
                        default:
                                    panicno("writen");
                                    return -1;
                        }
                }

		nleft -= nwritten;
		ptr   += nwritten;
	}
        //*n =  *n - nleft;
	return(0);
}

